
  Previous Versions and Screenshots: https://kshutdown.sourceforge.io/releases/

2025-04-11  6.0

Note:

* Version 5.2 is outdated (released in 2019!) and no longer updated/supported
* Version 6.0 works with both Qt 5 (requires 5.15.x) and Qt 6
* Version 6.0 works with both KDE Plasma 5 and Plasma 6

Actions:

* NEW: Linux: Added "Unlock Screen" action

User Interface:

* NEW: Added the Ukrainian translation
* NEW: Show Progress Bar settings menu also in the Preferences window
* Updated the Polish translation
* Fixed missing Lithuanian translation in Qt/win32 Build
* Auto complete xscreensaver command and File Monitor path
* Hide "Check for Updates" menu item if not needed
* Improve confirmation messages
* Remove underline from links
* Minor UI tweaks

Preferences/Restart:

* FIXED: Wait for "grub-reboot" process start
* NEW: Boot entry name starting with "KS:-" is dispayed as a menu/list separator
* Added grub-reboot auto complete
* Quote grub-reboot "%entry" parameter

Misc.:

* Fixed XDG Autostart directory detection
* Tools → Run: Added "systemd-analyze time" command
* System Information: Clickable Config/Data directory links
* Extras: Cleanup help menu items
* Bookmarks: Confirm item remove

--ui-dialog/--ui-menu command line options:

* Support alias names (e.g. both "sleep" and "suspend")
* Improved error messages

Source:

* CHANGED: Use separated "build-kf5.tmp"/"build-kf6.tmp" directories instead of single "build.tmp"
* Use "SPDX-License-Identifier" and "SPDX-FileCopyrightText" info in file headers
* Remove remaining old KDE 4 code
* Minor code cleanup


2024-06-17  5.92-beta (6.x)

Known Issues:

* Configure Keyboard Shortcuts window: Local shortcuts column is not visible (KDE 6 bug)

* Disabling System Tray icon quits KShutdown (Qt bug, fixed in Qt 6.7.x)
  Workaround: Start KShutdown again

User Interface:

* NEW: Lithuanian translation by Moo
* UPDATED: Polish translation
* NEW: Bookmarks: Ctrl+D shortcut
* Show the current user/login name in Logout tool tip
* Minor tweaks and improvements

Linux:

* NEW: Now it is possible to create Autostart/Desktop/Menu shortcut easily.
       See menu bar → Tools → Create File Shortcut

* CHANGED: Always confirm Shut Down/Reboot/Logout action invoked from a launcher menu
           (right-click menu)

KDE/Plasma 6:

* NEW: Support for Plasma 6 and KDE Frameworks 6
* FIXED: Partially fixed Logout action (using "org.kde.Shutdown" D-Bus)
* FIXED: System Settings: Use "kcmshell6" to launch System Settings
* FIXED: Restore main window after system tray icon click (not my fault ;)

KDE/Plasma 5:

* System Settings: Updated "kcmshell5" module names

Time from Now trigger:

* NEW: Added "Presets" button

Misc.:

* NEW: Added "--scale" command line option to force User Interface size/scale (example: kshutdown --scale 2)
* Make the main window and dialogs easily resizable
* FIXED: Update colors after system theme change
* Use Em Dash as title separator
* Show "Icon Theme" name in System Information window
* Show "System Information" in a proper window
* "Run" menu: Show program description in a tool tip
* Various bugfixes and tweaks

Preferences window:

* Use side list instead of top tabs
* Added titled separators
* Better widgets spacing

Source:

* NEW: Basic unit test support (./tools/test.sh)
* API: Use std::filesystem::path instead of QFile/QFileInfo/QDir
* NEW: Support Qt 6 and KF6 in CMakeLists.txt
* Updated build scripts for Qt 6 and KF6
* Replace deprecated/removed API (fixes compilation errors)
* Fixed compile errors on newer mingw (requires explicit path.string)
* CHANGED: Use 7zz (maintained Linux 7-Zip port) instead of 7z
* REMOVED: Replace generated "portable.pri" file
* Minor code cleanup and modernizations


2023-12-17  5.91-beta (6.x)

User Interface:

* CHANGED: Select the "Sleep" action by default instead of "Shut Down"
           (first application run only)
* REMOVED: "Use old action names" option.
           The new action names are now always used in KShutdown UI.
* NEW: Digital Countdown progress indicator
       (see the "Show countdown in the main window" option)
* CHANGED: Help → Configure Language moved to Tools menu (for consistency with other KDE apps)
* Added Help → Home Page menu item
* Various minor tweaks

Restart Action:

* NEW: Added option to set a custom boot entry command
* Hide "System" combo box if Restart → Show in Main Window option is not selected

Date/Time Event:

* NEW: Added "Now" button which sets the current date and time

Extras Action:

* Fixed program launching

Show Message Action:

* Multi-line message editor

System Tray:

* NEW: Customizable colors
* REMOVED: "Black and White System Tray Icon" option
* Fixed "<qt>" tags in system tray tool tip

Bookmarks Menu:

* CHANGED: Added "Remove" submenu; removed "radio" buttons

Misc.:

* UPDATED: Hungarian translation (by Egyed Ferenc)
* UPDATED: Russian translation (by Beliy)
* UPDATED: Slovak translation (by Jozef Gaal)

* CHANGED: Tools → Run: Use "last" command instead of the very slow "journalctl --list-boots"
* Cleanup and improve "Remaining time" messages
* Cleanup window icons
* Fixed missing icons
* REMOVED: Razor-qt Desktop Environment support
* FIXED: Ensure the application config is always written

Progress Bar (right-click menu):

* NEW: Configurable background color

Logging:

* Use colorized output only if terminal is present
* Improve formatting
* Log detailed KShutdown/Qt version on startup

Command Line:

* NEW: Added "--idle" command line option (alias to "-i")
* Added "Command Line Options" menu item shortcut

Windows:

* Add missing LICENSE.txt and README.html files

Source:

* CHANGED: Require Qt 5.15.x (or 6.x) to compile and run
* Better Qt 6 support
* Experimental support for Qt 6/win64 build
* CHANGED: Enable and use c++17 standard
* Cleanup and unify various QProcess-related APIs
* Basic AppImage support (no binary build yet)
* Auto show warnings reported by "i18nspector" while building the language
  translations using ./tools/i18n.sh (need optional "i18nspector" package)
* Convert end-of-line format from to DOS to Unix
* Various code cleanup and API refactoring


2021-09-29  5.90-beta (6.x)

* NEW: EXPERIMENTAL: Multi-booting (GRUB Entries) support
  - For example, allows reboot from Linux to Windows
    without selecting it manually in the GRUB menu.
  - See Tools → Settings → Restart for examples
  - See also: "--system" command line option
  - NOTE: Currently this is Linux only feature

* NEW: Added "File Monitor" trigger (detects a file remove/create).

* CHANGED: Future KShutdown versions will be released as 5.9x-beta/6.0
  (instead of 5.3-beta/5.4 as previously planned)

User Interface:

* NEW: Configurable (global) shortcuts to show main window/show the Actions menu.
  - Show Action Menu      - equivalent of right clicking on the system tray icon
  - Show/Hide Main Window - equivalent of left clicking on the system tray icon

* NEW: Updated main window UI
* Fixed missing icons
* Improved support for dark color themes
* Improved "--ui-dialog" UI
* Various minor UI tweaks and improvements

Misc.:

* Updated the Hungarian translation (by Egyed Ferenc)
* Updated the Polish translation
* Updated the Russian translation (by beliy)
* CHANGED: Colorized log output

* FIXED: https://sourceforge.net/p/kshutdown/bugs/40/
  (KShutdown icon is wrong on Wayland session of KDE Plasma desktop environment)

* Do not show popup menus near the mouse cursor to avoid accidental "Shut Down" click

* CHANGED: Main window: "OK" button renamed to "Activate"
  (also removed "Press OK to activate KShutdown" hint)

* Improved colors and fonts in "Command Line Options" window
* Windows: Hidpi-aware installer (non blurry window text)
* NEW: Added Help → System Information menu item
* FIXED: Custom menu shortcuts no longer disappear after application restart
* FIXED: Workaround for disabled Sleep/Hibernate actions shortly after a Desktop Environment start

* NEW: Show warning if installed KShutdown version is older than 2 years
  (NOTE: the warning is very subtle and does not affect any KShutdown functionality)

* --version command line option:
  - Show basic system info
  - Now works in MS Windows

* FIXED: Workaround for non-ASCII digits in some Chinese time formats
  (e.g. Simplified Han, Hong Kong SAR on Windows 10)

* NEW: Linux: Tools → Run menu: Add more "journalctl" commands
* FIXED: Use "C" locale in some date/time formatting/parsing
* FIXED: Use "C" date/time format for consistency with other parts of the User Interface

Source Code:

* NEW: Basic Support for Qt 6.x (Qt 5 is still used by default)
* CHANGED: Requires Qt 5.12.x or later to compile
* Replace signal/slot with lambda and remove unnecessary Q_OBJECT for faster compilation
* Replaced deprecated Qt API
* Minor C++ code modernizations and cleanup
* Workaround for wineconsole crash when building win32 version using Wine
* New *.desktop file parser and writer
* Full Log: https://sourceforge.net/p/kshutdown/code/1037/log/?path=/trunk


2019-12-30  5.2

* NEW: Experimental: Added "--ui-dialog" command line option.
  This option allows you to create a custom dialog window (buttons only; no timer).
  Items are arranged in a grid layout from left to right ("=" element creates a new row).

  Syntax: --ui-dialog item1[:item2][:item3]
  Valid items:
  Buttons                    : shutdown, reboot, lock, logout, hibernate, suspend, cancel, quit, test
  Separator/Gap              : -
  Row Wrap (--ui-dialog only): =
  Menu Title (--ui-menu only): title

  Example commands:

  $ kshutdown --ui-dialog suspend:-:reboot:shutdown

  $ kshutdown --ui-dialog shutdown:reboot:-:logout:=:suspend:lock:=:-:-:-:quit

  Note: The same syntax works with the "--ui-menu" option.

Misc:

* About window: Move "About Qt" button to the bottom buttons panel
* Update GPL license www links
* Updated the Polish translation
* CHANGED: Run external programs/commands as "detached" which may fix some issues

Windows:

* UPDATED: Qt library in version 5.13.1

Source:

* FIXED: Added proper way to enable C++14 standard and fix compile error
  Bug: https://sourceforge.net/p/kshutdown/bugs/38/
* REMOVED: Obsolete stats.cpp and stats.h files
* CHANGED: i18n: Do not include line numbers in generated *.po/*.pot files
* Fixed some "QString::null" warnings (other "deprecated" warnings will be fixed later)
* Minor code cleanup


2019-07-24  5.1-beta

* CHANGED: New action names that matches more closely
  the terminology used in current Desktop Environments.
  You can select "Use old action names" option if don't like the change.

* NEW: Added Help|What's New? menu item

* NEW: Added --logoff, --restart, and --sleep command line option aliases
  (run kshutdown --help for details)

Misc.:

* CHANGED: Do not show "Ctrl+Q" shortcut in system tray menu
* CHANGED: Tweaked popup notifications autohide timeout
* FIXED: Better default keyboard focus in dialog windows
* NEW: Added "Wiki" link button to the "Command Line Option" help window
* Qt5: About window:
  - Links can be selected and opened using Tab/Enter keys
  - Selectable text

Linux:

* NEW: Tools|Run menu: Added boot-related "journalctl" commands

Windows:

* UPDATED: Qt library in version 5.13.0
* UPDATED: NSIS installer in version 3.04

Haiku OS:

* Partially fixed Shut Down and Restart actions
* NEW: Added Lock action support

Source:

* CHANGED: Simplify and normalize application versioning.
  Now all versions are in format: "mm.ii" plus optional "-beta" suffix.
  This mostly apply to:
  - versions displayed in KShutdown GUI
  - default download URLs
    (e.g. sourceforge.net/projects/kshutdown/files/KShutdown/$VERSION/kshutdown-source-$VERSION.zip/download)

* UPDATED: "VERSION" file format and related files
* REMOVED: "test-wine.bat"; use "Setup-wine.sh" instead
* REMOVED: Obsolete "kshutdown.nsh" file (version number is now passed as /DAPP_VERSION option)
* Code cleanup


2019-05-04  5.0

* NEW: Added option to focus/select "Cancel" button by default in confirmation message
* NEW: Added Tools -> Run menu with various related Linux commands
  (this replaces "Statistics" menu item)
* Improve error message in the process list combo box

Windows:

* UPDATED: Qt library to version 5.11.2

Source:

* Added .editorconfig file with sane text format defaults
* Fixed: Remove autogenerated files before creating source package
* Updated win32 build scripts

Versioning:

* Major version number is now "5" to better align with Qt 5/KF 5 versions numbers.
* Older KShutdown 4.2 still works with Qt 4/KDE 4.


2018-10-15  4.99 Beta (5.x)

* CHANGED: KShutdown 5.x now requires Qt 5.9 or newer
* REMOVED: Qt 4 support
* REMOVED: KDE 4 support
* REMOVED: Windows XP/Vista support (requires Windows 7/10 or newer, 32/64-bit)

If you need any of the above, there are other options for you:

KShutdown 4.x downloads:
https://sourceforge.net/projects/kshutdown/files/KShutdown/

KShutdown 4.x source branch (minor bugfixes and updates only):
Clone: svn co https://svn.code.sf.net/p/kshutdown/code/branches/kshutdown-4.x

----

KF5 = a KShutdown version compiled using KDE Frameworks
Qt5 = a KShutdown version compiled using plain Qt 5 libraries only

Misc.:

* CHANGED: New command line option parser.
  This fixes some previous issues. However, the new parser is more strict
  and may print a warning if passed application options are malformed or incomplete.
* NEW: Progress Bar context menu: Show size/position preview icons
* NEW: Added Help|Command Line Options menu item
* NEW: Added "--confirm-auto" command line option (see --help)
* UPDATED: Spanish translation (by Pier Jose Gotta Perez)
* Improve info/warning message bars (smaller icons, nicer colors)
* CHANGED: Version format is now slightly different:
  - $MAJOR.$MINOR_EVEN - stable version (e.g. 5.0, 5.2)
  - $MAJOR.$MINOR_ODD-beta - Beta version (e.g. 5.1-beta, 5.3-beta)
  - Note that package file names now include "-" (dash) before "beta".
  - Version numbers displayed in UI are formatted like before (e.g. 5.1 Beta)
* FIXED: "--confirm" option can now work together with "--ui-menu" option
* REMOVED: Unused "?" button from window title bars
* Enable hi-dpi UI icons
* + Minor bugfixes and updates

Linux:

* CHANGED: Executable name in all build types is now "kshutdown[.exe]" instead of "kshutdown-qt[.exe]".
           NOTE: "make install" will create a "kshutdown-qt" symbolic link for compatibility.
           The launcher shortcut also has changed from "/usr/share/applications/kshutdown-qt.desktop"
           to "/usr/share/applications/kshutdown.desktop"
* FIXED/CHANGED: Install icons in "share/icons/hicolor/*/apps/kshutdown.png"
                 instead in "share/icons/hicolor/*/actions/kshutdown.png"
* NEW: Show countdown progress bar in taskbar entry. Works with Plasma (sort of), GNOME, and Unity.
* NEW: (KF5) Added application crash handler with option to restart KShutdown or report an issue
* (KF5) Better integration with Plasma desktop
* CHANGED: Respect "Confirm Action" option in app launcher context menu
* CHANGED: "--help" contents is now always displayed in a window rather than printed to stdout
* System Tray settings: Show "May not work correctly with some Desktop Environments" warning
* FIXED: GNOME/Unity: Do not display "<br>" and "<qt>" markup tags in a notification text
* KDE: Show icons in Preferences tabs
* CHANGED: (KF5) Move "System Settings..." button to the Tools menu
* NEW: (Qt5 on Plasma) Show "System Settings..." in Tools menu
* FIXED: (KF5) "Enable System Tray Icon" option can be used like in other KShutdown builds
* FIXED: (KF5) "--hide-ui" option hides system tray icon like in other builds

Extras menu:

* FIXED: Display folder names with a "dot" correctly
* REMOVED: Obsolete example folders
  (any existing "/usr/share/kshutdown/extras" directory can be removed manually)
* CHANGED: Create a single "Stop VLC Media Player" example on first KShutdown run
* FIXED: Garbled UTF-8 text in some menu elements

MS Windows:

* NEW: Show countdown progress in taskbar entry
* CHANGED: Using Qt 5.x instead of old 4.8.x
* REMOVED: "/?" command line option; use "--help" instead
* FIXED: Uninstaller: Ask before removing user settings

Source:

* CHANGED: Require Qt 5.9 or newer to compile
* NEW: Enable and use c++14 standard
* CHANGED: Incorrect combination of KS_PURE_QT/KS_KF5 defines will result in a compile error
* CHANGED: Cleaned up #defines:
  - KS_NATIVE_KDE -> KS_KF5
  - KS_DBUS -> QT_DBUS_LIB
  - KS_UNIX -> !Q_OS_WIN32
* CHANGED: Require NSIS 3.x to create an installer for Windows with Unicode support
* CHANGED: In all build types (KF5/Qt5), executable name is now "kshutdown" instead of "kshutdown-qt"
* NEW: Setup-qt5.bat
* REMOVED: Setup-qt4.bat and Setup-qt4.sh
* REMOVED: U_* macros
* REMOVED: Unused KDE 4 code
* Fixed and clean up "tools" scripts
* CHANGED: Setup-wine.sh: Use a separated Wine profile (~/.wine-kshutdown) and force 32-bit architecture
* Move command line related stuff to "commandline.*" files and "CLI" class
* Move all action/trigger classes to a dedicated plugins.cpp/h files
* Cleanup build scripts
* (Qt5): cmake: Enable "automoc" for faster compilation
* + Various code cleanups

New Known Issues:

* cmake: If you get "(...) bootentry.h: No such file or directory" error
  try to run cmake from non-symlinked directory, e.g. cd "$(realpath .)"


2017-10-16  4.2

* Fixed: Password on Cancel bypasses the Action setting (bug #33)
* Statistics: Added Ctrl+Shift+S shortcut
* Updated the Polish translation

Linux:

* Fixed: Suspend only works the second time (bug #34)
* Fixed missing Ctrl+Q shortcut in some Desktop Environments
* Fixed: Show application main window if KShutdown is already running
* When Selected Application Exit trigger:
  - Fixed combo box selection of root and non-own processes
  - Fixed root and non-own processes exit detection

Source:

* Removed semi-private KDevelop project files
* Updated links and args in tools/*.sh scripts


2017-08-24  4.1.1 Beta

Linux:

* NEW: Show standard KShutdown actions in the launcher/taskbar context menu (KF5 build only).
  This works with Plasma, Unity, GNOME, and other DEs that support "Desktop Actions".

Plasma:

* Fixed blurry system tray icon (Breeze theme) <https://sourceforge.net/p/kshutdown/bugs/27/>
* Removed the standard "Restore" and "Quit" actions from the status icon menu.
  Add "Quit KShutdown" instead which is less annoying (no confirmation message)
  and more consistent with the rest of the application.
* Experimental: Show progress bar in taskbar (disabled in this release)

Xfce:

* Show status notifier (aka system tray) icon (KF5 build only)
* NEW: Enable "Logout" action. In previous versions the action could break the already fragile Xfce session system.
  If the problem still exists and Xfce is starting w/o window manager:
  1. Exit Xfce
  2. Remove ~/.cache/sessions

GNOME:

* Logout Action: Fixed session manager "freeze" in GNOME-based Desktop Environments
* Drop GNOME 2 support (existing features should continue to work in KShutdown 4.x as before)

Windows:

* Installer: Remove "License Agreement" because GNU GPL is not an EULA
* Nicer system tray icon
* Add KShutdown logo icon to the kshutdown.exe file

Unity:

* Show system tray/notification icon
  NOTE: may not work 100% correctly due to Qt or Unity issues;
  also may not work correctly in older Unity versions
* Fixed: Never hide the main window completely because there is no way to unhide it in Unity
* Show menu bar again
  NOTE: global menu bar may not work correctly in older Unity versions
* Experimental: Show progress bar in taskbar (disabled in this release)

Openbox:

* Fixed Logout action <https://sourceforge.net/p/kshutdown/bugs/31/>
* Fixed Openbox detection

System Tray:

* Fixed: Always show main window on system tray icon click (even if it was minimized)
* Remove leading/duplicated "KShutdown" text from the tool tip text
* CHANGED: Linux: Now the "Black and White System Tray Icon" option is available only if "Use System Icon Theme" is unselected
* Removed small overlay icons (were barely visible anyway)

Preferences:

* Always show both OK and Cancel buttons in GTK-based Desktop Environments
* CHANGED: System Settings button (formerly "Related KDE Settings..."):
  - New icon
  - Visible only if running under Plasma and compiled using KDE Frameworks
  - Updated list of visible control panel modules

Misc.:

* CHANGED: Main Window: Do not focus OK button on startup to avoid accidental action activation via Enter key
* Print values of DESKTOP_SESSION and XDG_CURRENT_DESKTOP environment variables on startup
* Updated README.html file
* Added some menu bar key shortcuts
* Various minor cleanups and updates

Setup.sh:

* Run make with "-j2" options for faster compilation
* Show proper error if "dialog" program is missing
* Improve run/installation instructions
* Select "kshutdown-kf5" or "kshutdown-qt5" by default (instead of Qt 4-based builds)
* Mark "kshutdown-kde4" and "kshutdown-qt4" as obsolete
* Include "kshutdown-qt5" and "kshutdown-qt4-win32" in menu

Setup-kf5.sh:

* Fixed: "(...) bootentry.h: No such file or directory" fatal error if compiling from symbolic link directory

Setup-qt5.sh:

* Fixed: Explain how to fix:
  qmake: could not exec '/usr/lib/x86_64-linux-gnu/qt4/bin/qmake': No such file or directory

Setup-kde4.sh:

* Removed auto installation using kdesu

Source:

* CHANGED: Move ./tools/VERSION to the top-level directory (./VERSION)
* CHANGED: Add "release date" to the ./VERSION file
* Cleanup *.h header includes
* Removed ./tools/flint++.sh
* Updated ./tools/clang-tidy.sh and ./tools/scan-build.sh
* Minor code cleanups


2017-04-17  4.1 Beta

* Better tool tips in menus (requires Qt 5.1+) (feature-request #21)
* Removed ambiguous "Build" text from version info.
  yyyy-MM-DD string now refers to the official release date rather than
  build/compilation date.
* Nicer font in About|License tab
* Update Portuguese translation (thanks to Américo Monteiro)
* Better icon in confirmation message box
* UI: Use pixel metrics instead of hardcoded values
* Fixed: Process List: Do not truncate command names with spaces
* Update links to use encrypted https://kshutdown.sourceforge.io/
  instead of http://kshutdown.sourceforge.net/

Command Line

* --ui-menu: show confirmation box only if --confirm option is set
* --version: Print correct Qt version

Linux:

* NEW: Added "Use System Icon Theme" option (bug #27)
* Fixed: Disable broken global/appmenu
* Various system tray related fixes (bug #27)
* Qt 5 Build: Fixed double "KShutdown" text in window title

Source:

* Qt Build/cmake: Install "kshutdown.png" icons (bug #29)
* Use install(TARGETS) to install the kshutdown binary
  (patch #6 by Raphael Kubo da Costa)
* Added ./tools/clang-tidy.sh script
* cmake: Auto generate compile commands (used by clang-tidy)
* Fix compilation error with Qt4 (bug #30)
* Qt Build/cmake: Include missing translations and application icons
* Auto show warnings reported by POFileChecker while building language
  translations using ./tools/i18n.sh (need optional gettext-lint package)
* Modernize code:
  - 0 -> nullptr
  - Use " = default" destructors
  - Use "auto"
* Minor code cleanup
* Minor docs update

Windows:

* Update Qt libraries to version 4.8.7


2016-08-30  4.0

Qt Build:

* NEW: Use the standard Ctrl+Q shortcut instead of Ctrl+Shift+Q (bug #26)
* Fixed: Support "--version" command line option (bug #26)
* Command Line: Ignore "/?" option in non-Windows versions
* Fixed: Honor $INSTALL_ROOT environment variable when installing icons (bug #25)
* Fixed: Remove icons during "make uninstall"

Misc:

* Czech translation update (Pavel Fric)
* Updated German translation (Vinzenz Vietzke)
* Updated Russian translations (Victor Ryzhykh)
* Updated Polish translation

* Fixed: Make menu titles less distractive and less annoying
  (feature request #21)
* Fixed: Disable incorrectly positioned tool tips in System Tray menu
* Windows: Updated installer

Linux:

* Use uncompressed SVG icon (bug #21)
* Adjust kshutdown.desktop (patch #5):
  - Added StartupNotify=true/false
  - Added X-SuSE-DesktopUtility category

Source:

* Fix compiler warnings
* README.html: Document "Required Libraries" (bug #23)


2016-04-29  3.99.1 Beta  "4.x"

Command-Line:

* NEW: Support AM/PM time format (e.g. "8:15 pm")
* Fix regression in "--hide-ui" option
* Fixed: Allow "--style" (with double dash) option to change default style
* EXPERIMENTAL: Added "ui-menu" option.
  It allows you to show custom popup menu instead of main window.
  Example: kshutdown --ui-menu lock:-:logout:shutdown:-:quit
  Bugs: Works in KDE/Qt5 builds, but not in Qt4-only builds...

Linux:

* NEW: Basic LXQt support
* NEW: Added "Custom Lock Screen Command" option
  (set if your default screen locker sucks ;)
* NEW: Add logging out for openbox WM (feature-requests #20)

Progress Bar:

* Show main window on left button click
* Show "Cancel" action in context menu
* Cleanup context menu
* Add "Progress Bar" text to the window tool tip and title to avoid confussion

Process List:

* Remember recently selected command/window name
* Exclude internal "w" and "kshutdown" processes from the list
* Show warning if a selected process does not exist anymore
* Faster refresh and sorting

Password Box:

* Fixed: Show input window again if entered password was incorrect
* Fixed: Clear password text from RAM memory after use

Misc.:

* Fixed: Better text selection in time input field after double click
  (fixes Up/Down key and mouse wheel editing)
* NEW: Bookmarks: Added "Confirm Action" option
* Fixed: Include missing language translations in non-KDE builds
* NEW: Help|About (Qt Build):
  - New layout
  - Added "What's New?" link with release notes
* Always show action and program icons in menus
* Minor UI tweaks
* Minor bug-fixes and improvements

Source:

* Minor code cleanup
* Enable more compiler warnings (-Wextra -Wpedantic -Wswitch-enum)
* Setup-kde: Enable "automoc" option for faster compilation


2015-10-10  3.99 Beta

Linux:

* NEW: Initial/experimental port to KDE Frameworks 5
  (see ./Setup-kf5.sh and README.html)
* NEW: Basic Trinity Desktop support (added Logout and Lock)
* Fixed: Use both DESKTOP_SESSION and XDG_CURRENT_DESKTOP environment variables
  to detect Desktop Environment
* Fixed: Disable global menu in Unity (fixes Bookmarks menu and key shortcuts)
* Fixed: Ensure GetSessionIdleTime D-Bus function is actually implemented

Misc.:

* Remove "Maximize" button
* Minor fixes in time display format
* Auto switch to next day in case of invalid date
* README.html updates:
  - Add "Qt Build (Windows)" section
  - Update "Configuration Files"
  - Add "Installed Files"
* Minor bugfixes and updates

Source:

* cmake: Support Qt5 Build (patch #4, see README.html)


2015-07-02  3.3.1 Beta

Linux:

* Fixed: Workaround for "No valid org.freedesktop.ConsoleKit interface found" error
* Add Tools|Statistics menu item (currently it is output from the "w" command)

User Inteface:

* Avoid smaller text fonts
* Remove Help|What's This? menu item
* Clean up menu bar
* Show tool tips in Action and Bookmarks menus
* Show a small note that 24h+ delay is not recommended
* Fix minor issues

Command-Line:

* Allow "h" and "m" time suffixes.
  Example: 2h (two hours), 10m (ten minutes)
* Better "--help" output formatting

Extras Menu:

* Show command to execute in tool tip
* Better menu item names
* Fix launching commands with a long file name

Source:

* Clean up TODO list
* Update Doxygen configuration
* Minor code clean up; fix lint warnings


2014-12-02  3.3 Beta

* NEW: Allow custom bookmark names
* Increase minimum required password length to 12 characters
* Updated the Polish and Russian translations
* Updated README.html documentation
* Fixed: Reduce the number of debug messages printed to stderr/console
* Renamed "Quit" action to "Quit KShutdown"
* NEW: Add "--mod" command-line option
  (allows various UI tweaks such as progress bar opacity or color themes;
  to be documented and continued...)
* NEW: Added "--portable" command-line option to run KShutdown in a portable mode.
  This works only with "kshutdown-qt" build and KShutdown for Windows.
  The standard version for KDE will stop with "Unknown option 'portable'" error.
* NEW: Flash taskbar button 1 or 5 minutes before action timeout
* Updated About window (show build date in yyyy-mm-dd format; better text layout)
* Show "Press OK to activate KShutdown" hint
* Fix text wrap and spacing in notification text

Linux:

* Fixed: Do not override/ignore "-style" command-line option
* Added keywords to the KShutdown menu entry
  (for example you can type "halt" or "logout" to search for KShutdown launcher)
* D-Bus: Show actions/triggers list in sane order
  (example command: qdbus net.sf.kshutdown /kshutdown triggerList false)
* MATE: Fixed various system tray icon issues
* Qt Build: Disable idle detector on KDE (known KDE bug)
* Fixed: Do not initialize deprecated HAL D-Bus interface on application startup
* KDE: Better "--help" output

Windows:

* Support Qt 4.8.6 library and newer MinGW
* Update/simplify installer

Extras Action:

* Fixed: Show "(Empty)" text if Extras folder does not contain any items
* Added "Do not show this message again" option

Settings Window:

* Autoselect recently visited tab
* KDE: Added tab icons
* Fix minor UI layout issues

Source:

* NEW: scan-build support (./tools/scan-build.sh)
* Fix minor issues reported by static analyzers
* Updated examples in ./Setup* scripts
* Improved ./tools/make-version.h
* NEW: cmake: support Qt5 build <http://sourceforge.net/p/kshutdown/patches/4/>
* NEW: Added flint++ (C++ Linter) support (./tools/flint++.sh)
* C++ code clean up:
  - Add "override"
  - Add missing "virtual"
  - Use typesafe "enum class"
  - Remove some "inline" directives
  - Use C++11 R"( for better strings readability
  - Fix _WIN32_WINNT-related warnings
* Update build instructions for Wine/Win32
* Updated utility scripts


2014-02-23  3.2

* Czech translation update
* Updated the Polish translation
* Fixed language translations in some common UI elements
* Minor User Inteface tweaks
* Fixed: Disable "OK" button if new password is invalid

Linux:

* NEW: systemd/logind support (Power Off, Reboot, Hibernate, Suspend)
* NEW: Added basic Cinnamon Desktop Environment support
* GNOME 3: Fixed detection and logout action


2013-12-06  3.1 Beta

* NEW: Simple password protection
  (see menu bar -> Settings -> Password tab)
* Updated README.html
* Updated the Spanish translation (by moray33)
* Updated the Polish translation
* Qt Build: Allow logout from KDE 4
* NEW: "Test" action:
  - Renamed to "Show Message"
  - Configurable text

Source:

* NEW: Removed "kworkspace" library dependency
  (libkworkspace is no longer required to build KShutdown for KDE)
* Enable C++11 support
* cppcheck tool support (./tools/cppcheck.sh)
* Windows: Fixed compilation errors


2013/07/09  3.0

* Updated Czech translation
* Updated Simplified Chinese translation (by xStone)
* Bookmarks menu: Mark the current/selected bookmark
* Windows: Use the latest Qt 4.8.5
* README: Added alternate Qt 5.1 build instructions


2013/06/16  3.0 Beta 8

* NEW: Bookmarks menu
* Linux: Fixed bug #19 (kshutdown refusing to do shutdown)
* Czech translation update
* Updated Polish translation


2013/04/09  3.0 Beta 7

* NEW: MATE Desktop Environment support
* NEW: Razor-qt Desktop Environment support
* Updated Serbian translations
* Updated Brazilian Portuguese translation
* Unified system tray icon view and options in all KShutdown versions
* Fixed -e and --extras command line options
* Fixed transparent background in "kshutdown" icons; reduced "kshutdown.ico" size

KDE:

* NEW: Use native message views (KMessageWidget class)
* Require KDE 4.7+ instead of 4.4+
* Fixed: Fallback to ConsoleKit if KDE shutdown API is unavailable
* Disallow one-letter keyboard shortcuts


2013/02/12  3.0 Beta 6

* NEW: Haiku OS support (see README.html for build instructions)
* NEW: Qt 5 support
* Disable drop shadow and input focus in progress bar and screen lock windows
* KDE: Extras: Removed unreliable "Unlock Screen" action
* KDE: Workaround for org.freedesktop.ScreenSaver.GetSessionIdleTime bug
  (causes wrong time calculations in the "Inactivity Detector")

Windows:

* Updated Qt libs/dlls (v4.8.4)

Documentation:

* Fixed broken www links

Source:

* Changed minimal required Qt version from 4.6 to 4.8
* Fixed compiler warnings
* Fixed FreeBSD detection <http://sourceforge.net/p/kshutdown/bugs/18/>


2012/11/24  3.0 Beta 5

-- Test 3 ----------------------------------------------------------------------

Setup scripts:

* Removed kdesudo (optional package) dependency
  <http://sourceforge.net/p/kshutdown/bugs/16/>
* Fixed confusing "ERROR: Build failed..." message

* Updated application description
* Updated sf.net and Wiki links

Source:

* Helper test script for Wine (./tools/test-wine.bat)

-- Test 2 ----------------------------------------------------------------------

* Fixed: https://bugs.launchpad.net/ubuntu/+source/kshutdown/+bug/1044213
  (update date/time status after resume)
* Include README.html file in portable package
* KDE: Extras: Use current/default file manager
  instead of hardcoded "/usr/bin/dolphin"
* Fixed small memory leaks

Progress Bar:

* NEW: Size configuration (see context menu)
* Fixed: Auto update location/width on screen size change

Source:

* Qt 5: Q_WS_* -> Q_OS_*, KS_UNIX, KS_DBUS

-- Test 1 ----------------------------------------------------------------------

Progress Bar:

* Improved Kiosk support
  <http://sourceforge.net/p/kshutdown/wiki/Kiosk/>
* Use KDE native color chooser

Extras:

* NEW: Support for non-KDE KShutdown versions
  <http://sourceforge.net/p/kshutdown/wiki/Extras/>
* NEW: Added Extras -> Stop -> VLC
* KDE: Do not show security/confirmation dialog for new *.desktop files
* Show command name in menu item

User Interface:

* Improved confirmation message box
* Changed "Quit" shortcut to Ctrl+Shift+Q
* KDE: Show credits, author, and bug report address in About box
* KDE: Show action keyboard shortcuts in menu
* Process Monitor: Linux: Show own processes on top of the list

Misc.:

* Updated Polish translation
* Smaller portable package compressed using 7-Zip

Windows:

* NEW: Added "When selected application exit" trigger
* Show icons in message panes
* Fixed: Removed "<qt>" tags from system tray tool tip
* Fixed: Force shutdown if screen is locked (Windows XP)
* Fixed shutdown issues caused by multiple logged in users
* Fixed: Hide "Do not save session" option if it's not needed

Windows Installer:

* "Autostart" option is now unselected by default
* Support for silent mode ("/S" option). Installer launched with /S option will
  install KShutdown in a default location without asking any questions :)
* Reduced installer size

Source:

* Fixed/suppressed issues reported by Krazy2 tool
* Win32: Fixed compilation
* Win32: Updated compilation instructions


2012/04/23  3.0 Beta 4

Progress Bar:

* Fixed: Show/hide progress bar on settings change
* Show progress bar in user inactivity detector
* NEW: Customizable color (progress bar -> context menu -> Set Color...)

Misc.:

* A more compact "Action" and system tray context menu
* Czech translation update
* Updated Polish translation
* Show error message if trigger (e.g. user inactivity detector) is not available
* Windows: Updated Qt DLLs (v4.8.1) and MinGW

README:

* Updated MinGW docs
* Added Clang (alternate C++ compiler) docs


2012/03/01  3.0 Beta 3

* NEW: Option to quit program when pressing close button
  instead of minimizing to tray (RFE #3494853)
* NEW: Option to hide system tray icon
* Fixed Alt+A keyboard shortcut which clashed with the C&ancel button
  (English translation only)

Updated language translations:

* Czech translation update. Thanks to Pavel Fric.
* Danish translation updates
* Italian translation updates
* Serbian translation updates

Source:

* KDE 4: Auto run "kdesudo" to install compiled KShutdown
* KDE 4: Fixed: KShutDown doesn't build on KDE 4.8
  Bug: http://sourceforge.net/tracker/index.php?func=detail&aid=3467712&group_id=93707&atid=605270
* Fixed compilation warnings


2011/12/30  3.0 Beta 2

* Version change: 2.1.1 Beta -> 3.0 Beta 2 (yes, 3.0 :)
* Serbian translation updates
* More readable tool tip text in tray icon and progress bar
* Command Line: Allow '0' time option (no delay)
* Better default date/time values
* Updated Polish translation

Linux:

* NEW: Shutdown/Reboot via ConsoleKit and/or HAL D-Bus interface.
  The Shutdown/Reboot action now should work
  with all Desktop Environments and Display Managers.
* NEW: KShutdown/Qt
  (version for Xfce and other non-KDE Desktop Environments,
  see README.html for details)
* Fixed: Added workaround for non-clickable HTML links in Oxygen Style
* Better integration with GTK-based Desktop Environments (Xfce, LXDE, etc.)
* Do not show button icons if this option is disabled by user
* Improved Desktop Environment detection

Linux/KDE:

* NEW: Option to Unlock the screen. See Extras -> Unlock Screen
* Extras: Updated Kaffeine entry
* Extras: Removed kdetv (KDE 3 only) entry
* Extras: Show error message if file does not exist

Linux/Xfce 4:

* Support Turn Off and Restart actions
* Fixed: Do not start krunner in non-KDE sessions
* Fixed missing icons in menu and combo box

Linux/LXDE:

* Logout Action

Linux/GNOME 3:

* More supported actions

Linux/Unity:

* Workaround for missing system tray support...

Linux/E17:

* Basic support
  - Load System->DBus Extension module for Lock Screen action support
  - Load Utilities->Systray module for system tray support

Windows:

* Use Windows terminology (Logout -> Log Off, Suspend Computer -> Sleep)
* Updated Qt DLLs (4.7.4)

Source:

* Fixed "Unable to find file for inclusion portable.pri" warning
* Fixed all *.desktop file warnings
* Added UDialog class - a base dialog
* Updated README.html and build scripts

Qt 4 Build (Setup-qt4.sh):

* Binary program is now called "kshutdown-qt"
* Added "make install" command.
  This will install kshutdown-qt,
  icons, and menu shortcut under /usr prefix directory.


2011/07/24  2.1 Beta (alias 3.0 Beta 1)

* Added Portuguese language translation (pt.po, bug #3292202)
  Thanks to Américo Monteiro
* Updated Polish translation
* Fixed: Do not activate disabled or unsupported action
* Fixed: Command Line: Do not show "Invalid time" error message for time values
  without leading zero
* Fixed a tiny system tray icon if launched with "--xx time" command line option
* Improved confirmation message box
* Faster Screen Lock function
* Minor User Inteface improvements and tweaks
* Use "kshutdown:" prefix in logs printed to the stderr

KDE 4:

* NEW: Added "Black and White System Tray Icon" option for better integration
  with dark color themes
* NEW: (Re)Added KDE Kiosk support. Documentation:
  http://sourceforge.net/p/kshutdown/wiki/Kiosk/
* NEW: (Re)Added Local and Global keyboard shortcuts
  (see menu -> Settings -> Configure Shortcuts...)
* Use KDE UI elements in KDE4 version for better platform integration
* Fixed KDE detection

Source:

* Added support for Krazy2 Code Checker (see ./tools/krazy2.sh)
* Fixed compilation on kfreebsd platform (bug #3292203)
* Fixed: Do not include temporary binary "kshutdown" file in a source package


2011/04/20  2.0

Version for Linux:

* Support for the UPower suspend/hibernate backend (patch #3224666)
  Thanks to Stanislav Nikolov
* Updated D-Bus Documentation:
  http://sourceforge.net/p/kshutdown/wiki/D-Bus/

Updated Language Translations:

* Brazilian Portuguese
* Danish
* Polish
* Russian

Version for Windows:

* Upgraded Qt libs (2010.05)
* Use dynamic Qt*.dll instead of static linking
* Fixed compilation error


2011/02/15  2.0 Beta 12

Linux:

* NEW: Added D-Bus support. Run "qdbus net.sf.kshutdown /kshutdown" for details.
  Documentation: http://sourceforge.net/p/kshutdown/wiki/D-Bus/
* Fixed bug #3140645 (kde 4.6 + qt 4.7.1 + kshutdown crash)
* Setup.sh: Auto select kde4 menu item (if available)
* Show error message if "Turn Off Computer" or "Restart Computer" function
  is not available or disabled in KDE System Settings.
* Fixed error in "When selected application exit" function caused by zombie programs

Command Line:

* NEW: Added "--cancel" command line option to stop an active action (KDE 4 only)
* NEW: Added "--confirm" option to confirm a command line action
* NEW: Added -i and --inactivity command line options
  (RFE #3052626, Command Line Inactivity Timer)

Misc.:

* Updated Brazilian Portuguese translation
* Updated Polish translation
* Updated Slovak translation
* Better icon size in system tray


2010/08/28  2.0 Beta 11

* KDE 4.5.0: Fixed huge memory leak and crash on KDE startup
* Fixed: Xfce: Do not show <qt> and <br> tags in notification window
* Updated Serbian translation
* Show "Global Keyboard Shortcuts" options in "KDE Related Settings" window
* UI: Activate main window on system tray icon click
* UI: Do not display scroll bars in combo box popups
* KDE: Use org.kde.krunner service if org.freedesktop.ScreenSaver
  is not available (used by Lock Screen action and inactivity detector).


2010/07/22  2.0 Beta 10

* NEW: Added "-hide-ui" command line option to hide all KShutdown user interface
  (main window and system icon)
* NEW: Show warning notification 30, 60, or 120 minutes before timeout
* NEW: Danish translation
* Command line help window (--help): Added link to
  http://sourceforge.net/apps/mediawiki/kshutdown/index.php?title=Command_Line
* Disable unsupported "Restart/Turn Off Computer"
  actions on GDM/GNOME/Xfce desktop
* Menu Bar: "File" menu renamed to "Action"
* Source: Added convenient installation script (./Setup.sh)
* Source: Added support for Qt4-only Builds (see ./Setup-qt4.sh or ./Setup.sh)
* NEW: Added "Test" action - an action that does nothing...
* Source: Added KDevelop 4.0 project support
* Updated Polish translation
* Updated Serbian translation
* Updated documentation


2010/03/13  2.0 Beta 9

* Updated Brazilian Portuguese translation
* Updated Serbian translation
* Updated Polish translation
* EXPERIMENTAL: Added user "inactivity" detector
  (see "Select time/event", Win32/KDE4 only)
* KDE 4: Highlight system tray icon if KShutdown is active
* Updated README.html file

MS Windows:

* Use Qt 4.6.x library
* Show command line help for "--help" and "/?" arguments
* Show notifcation message in system tray icon
* Updated installer

GNOME/Xfce 4 Support (EXPERIMENTAL):

* Added "Logout" action
* Show icons from the current Icon Theme
* Use Gtk+ style by default


2009/09/29  2.0 Beta 8

* Command Line: Added support for "time" option
  (KDE: run "kshutdown --help" for more info)
* Updated Polish translation
* Extras: Added help link
* Misc. bug fixes and improvements


2009/08/09  2.0 Beta 7

* NEW: Added "Cancel" action (see File and System Tray menu)
* Updated German translation (thanks to Markus)
* Updated Norwegian translation
* Updated Polish translation
* Display the "end" date/time in main window, tool tips, and notifications
* Action confirmation is now disabled by default
* EXPERIMENTAL: Added contextual help for "Hibernate" and "Suspend" actions
  (press Shift+F1 or select Help|What's This?)
* KDE: Fixed icon for the "Restart Computer" action
* KDE: Fixed "e" and "extra" command line options
* Removed "Theme" support (use QSS instead; see -stylesheet parameter
  <http://doc.trolltech.com/latest/stylesheet.html>)
* Misc. User Interface improvements

"Extras" Action (KDE4):

* Use Dolphin instead of Konqueror as the menu editor

"When Selected Application Exit" Trigger (KDE4):

* Show icons for the current user only (much faster)
* Show pid/user name in window title and system tray tool tip

Version for Windows:

* Updated Qt libs (v4.5.2)
* Show "No Delay" warning message in the "File" menu

Source:

* Improved CMakeLists.txt for the "po" directory (PATCH #2784970)
* EXPERIMENTAL: Use GTK+ Style on GNOME (Qt4 build only)
* Removed unused APIs
* LockAction moved to actions/lock.*
* Code clean up
* Fixed Win32 build
* Changed "include guard" name to avoid collisions
* Added "InfoWidget" class
* Renamed enums to avoid collision with other #defs
* Fixed small memory leaks
* Added Q_DISABLE_COPY and "explicit" keyword


2009/04/21  2.0 Beta 6

* KDE: Fixed crash on application startup if the
  "When selected application exit" option was selected
* KDE: Added convenient function to configure related KDE settings
* Updated Polish translation
* Fixed language translations


2009/04/01  2.0 Beta 5

* NEW: Added -H and -S (uppercase) command line options for Hibernate and Suspend
* NEW: Added Serbian translation
* Source: Added tools/api.sh (API documentation generator)
* Source: Added Doxyfile file (API documentation configuration)
* Fixed: no -> nb (Norway -> Norwegian Bokmaal)
* Updated Spanish translation
* Updated and fixed Polish translation


2009/01/15  2.0 Beta 4

* Fixed Hibernate/Suspend action in Ubuntu 8.10
* Remeber previous shutdown settings (BUG #2444169)
* NEW: Added Norwegian translation
* Updated French translation
* Extras Actions: Added support for regular executables files
  (e.g. shell script or compiled program)
* Show selected action name in notification popup message


2008/12/01  2.0 Beta 3

* NEW: Added progress bar (disabled by default; see Preferences)
* Separators in combo box list (this requires Qt 4.4+)
* Fixed "Desktop Entry" files

Linux/KDE 4 version:

* NEW: Added notifications. See menu -> Settings -> Configure Notifications...
* Use system theme icon in system tray
* Fixed: Remember recent Extras action

Linux version:

* NEW: Added language translations
* NEW: Added "When selected application exit" trigger

Windows version:

* Updated Qt Toolkit libraries to version 4.4.3
* Updated NSIS installer
* Updated build script

Source package:

* Added "Desktop Entry" file validator (./tools/check-desktop-files.sh)


2008/10/11  2.0 Beta 2

* Fixed "Logout canceled by..." message on KDE logout
* NEW: Added option to disable screen lock before hibernate/suspend
* Fixed Qt4 build
* Updated README.html file


2008/07/27  2.0 Beta 1

* NEW: Added "Extras" actions (KDE build only)
* Fixed "Turn Off Computer" icon
* Fixed Help menu; removed unused actions
* Fixed: OK/Cancel buttons in Preferences window
* Updated build scripts
* Fixed application shortcut


---- Release History ----

Old ChangeLogs can be found in the SVN repository at:

https://sourceforge.net/p/kshutdown2/code/HEAD/tree/trunk/kshutdown2/ChangeLog
https://sourceforge.net/p/kshutdown/code/HEAD/tree/trunk/kshutdown/ChangeLog

2008/04/02  2.0 Alpha 5

2008/01/20  2.0 Alpha 4

2007/11/25  2.0 Alpha 3

2007/07/08  2.0 Alpha 2

2007/06/24  2.0 Alpha 1

2009/??/??  1.0.5 for KDE 3 (never released)

2009/01/15  1.0.4

2008/05/26  1.0.3

2007/11/25  1.0.2

2007/07/08  1.0.1

2007/04/14  1.0

2006/10/10  0.9.1 Beta

2006/06/29  0.9 Beta

2006/02/05  0.8.2

2006/01/09  0.8.1

2005/11/27  0.8

2005/10/18  0.7.1 Beta

2005/07/02  0.7.0 Beta

2005/02/28  0.6.0

2005/02/12  0.5.1 Beta

2004/12/15  0.5.0 Beta

2004/11/13  0.4.0

2004/10/23  0.3.2 Beta

2004/09/11  0.3.1 Beta

2004/08/30  0.3.0 Beta

2004/07/19  0.2.0

2004/07/05  0.1.9 Beta

2004/06/13  0.1.8 Beta

2004/03/27  0.1.7 Beta

2004/03/11  0.1.6 Beta

2004/02/22  0.1.5 Beta

2004/02/07  0.1.4 Beta

2004/01/17  0.1.3 Beta

2003/12/08  0.1.2 Beta

2003/11/09  0.1.1 Beta

2003/10/27  0.1.0 Beta

// svn log -r 1197:HEAD|xclip -i -selection clipboard && kwrite ChangeLog
